Index: serefpolicy-contrib-20140730/pacemaker.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/pacemaker.fc
+++ serefpolicy-contrib-20140730/pacemaker.fc
@@ -1,5 +1,7 @@
 /etc/rc\.d/init\.d/pacemaker	--	gen_context(system_u:object_r:pacemaker_initrc_exec_t,s0)
 
+/usr/lib/systemd/system/pacemaker.*	--	gen_context(system_u:object_r:pacemaker_unit_file_t,s0)
+
 /usr/sbin/pacemakerd	--	gen_context(system_u:object_r:pacemaker_exec_t,s0)
 
 /var/lib/heartbeat/crm(/.*)?	gen_context(system_u:object_r:pacemaker_var_lib_t,s0)
Index: serefpolicy-contrib-20140730/pacemaker.if
===================================================================
--- serefpolicy-contrib-20140730.orig/pacemaker.if
+++ serefpolicy-contrib-20140730/pacemaker.if
@@ -1,9 +1,166 @@
-## <summary>A scalable high-availability cluster resource manager.</summary>
+## <summary>>A scalable high-availability cluster resource manager.</summary>
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an pacemaker environment.
+##	Transition to pacemaker.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`pacemaker_domtrans',`
+	gen_require(`
+		type pacemaker_t, pacemaker_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, pacemaker_exec_t, pacemaker_t)
+')
+
+########################################
+## <summary>
+##	Execute pacemaker server in the pacemaker domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`pacemaker_initrc_domtrans',`
+	gen_require(`
+		type pacemaker_initrc_exec_t;
+	')
+
+	init_labeled_script_domtrans($1, pacemaker_initrc_exec_t)
+')
+
+########################################
+## <summary>
+##	Search pacemaker lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`pacemaker_search_lib',`
+	gen_require(`
+		type pacemaker_var_lib_t;
+	')
+
+	allow $1 pacemaker_var_lib_t:dir search_dir_perms;
+	files_search_var_lib($1)
+')
+
+########################################
+## <summary>
+##	Read pacemaker lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`pacemaker_read_lib_files',`
+	gen_require(`
+		type pacemaker_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	read_files_pattern($1, pacemaker_var_lib_t, pacemaker_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage pacemaker lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`pacemaker_manage_lib_files',`
+	gen_require(`
+		type pacemaker_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_files_pattern($1, pacemaker_var_lib_t, pacemaker_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage pacemaker lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`pacemaker_manage_lib_dirs',`
+	gen_require(`
+		type pacemaker_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_dirs_pattern($1, pacemaker_var_lib_t, pacemaker_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Read pacemaker PID files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`pacemaker_read_pid_files',`
+	gen_require(`
+		type pacemaker_var_run_t;
+	')
+
+	files_search_pids($1)
+	allow $1 pacemaker_var_run_t:file read_file_perms;
+')
+
+########################################
+## <summary>
+##	Execute pacemaker server in the pacemaker domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`pacemaker_systemctl',`
+	gen_require(`
+		type pacemaker_t;
+		type pacemaker_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+	systemd_read_fifo_file_passwd_run($1)
+	allow $1 pacemaker_unit_file_t:file read_file_perms;
+	allow $1 pacemaker_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, pacemaker_t)
+')
+
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an pacemaker environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -19,14 +176,17 @@
 #
 interface(`pacemaker_admin',`
 	gen_require(`
-		type pacemaker_t, pacemaker_initrc_exec_t, pacemaker_var_lib_t;
+		type pacemaker_t;
+		type pacemaker_initrc_exec_t;
+		type pacemaker_var_lib_t;
 		type pacemaker_var_run_t;
+		type pacemaker_unit_file_t;
 	')
 
 	allow $1 pacemaker_t:process { ptrace signal_perms };
 	ps_process_pattern($1, pacemaker_t)
 
-	init_labeled_script_domtrans($1, pacemaker_initrc_exec_t)
+	pacemaker_initrc_domtrans($1)
 	domain_system_change_exemption($1)
 	role_transition $2 pacemaker_initrc_exec_t system_r;
 	allow $2 system_r;
@@ -36,4 +196,13 @@ interface(`pacemaker_admin',`
 
 	files_search_pids($1)
 	admin_pattern($1, pacemaker_var_run_t)
+
+	pacemaker_systemctl($1)
+	admin_pattern($1, pacemaker_unit_file_t)
+	allow $1 pacemaker_unit_file_t:service all_service_perms;
+
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
 ')
Index: serefpolicy-contrib-20140730/pacemaker.te
===================================================================
--- serefpolicy-contrib-20140730.orig/pacemaker.te
+++ serefpolicy-contrib-20140730/pacemaker.te
@@ -5,6 +5,13 @@ policy_module(pacemaker, 1.1.0)
 # Declarations
 #
 
+## <desc>
+## <p>
+## Allow pacemaker memcheck-amd64- to use executable memory
+## </p>
+## </desc>
+gen_tunable(pacemaker_use_execmem, false)
+
 type pacemaker_t;
 type pacemaker_exec_t;
 init_daemon_domain(pacemaker_t, pacemaker_exec_t)
@@ -12,17 +19,20 @@ init_daemon_domain(pacemaker_t, pacemake
 type pacemaker_initrc_exec_t;
 init_script_file(pacemaker_initrc_exec_t)
 
+type pacemaker_var_lib_t;
+files_type(pacemaker_var_lib_t)
+
+type pacemaker_var_run_t;
+files_pid_file(pacemaker_var_run_t)
+
 type pacemaker_tmp_t;
 files_tmp_file(pacemaker_tmp_t)
 
 type pacemaker_tmpfs_t;
 files_tmpfs_file(pacemaker_tmpfs_t)
 
-type pacemaker_var_lib_t;
-files_type(pacemaker_var_lib_t)
-
-type pacemaker_var_run_t;
-files_pid_file(pacemaker_var_run_t)
+type pacemaker_unit_file_t;
+systemd_unit_file(pacemaker_unit_file_t)
 
 ########################################
 #
@@ -30,13 +40,15 @@ files_pid_file(pacemaker_var_run_t)
 #
 
 allow pacemaker_t self:capability { fowner fsetid kill chown dac_override setuid };
+allow pacemaker_t self:capability2 block_suspend;
 allow pacemaker_t self:process { setrlimit signal setpgid };
 allow pacemaker_t self:fifo_file rw_fifo_file_perms;
 allow pacemaker_t self:unix_stream_socket { connectto accept listen };
 
 manage_dirs_pattern(pacemaker_t, pacemaker_tmp_t, pacemaker_tmp_t)
 manage_files_pattern(pacemaker_t, pacemaker_tmp_t, pacemaker_tmp_t)
-files_tmp_filetrans(pacemaker_t, pacemaker_tmp_t, { file dir })
+manage_fifo_files_pattern(pacemaker_t, pacemaker_tmp_t, pacemaker_tmp_t)
+files_tmp_filetrans(pacemaker_t, pacemaker_tmp_t, { fifo_file file dir })
 
 manage_dirs_pattern(pacemaker_t, pacemaker_tmpfs_t, pacemaker_tmpfs_t)
 manage_files_pattern(pacemaker_t, pacemaker_tmpfs_t, pacemaker_tmpfs_t)
@@ -60,13 +72,13 @@ kernel_read_system_state(pacemaker_t)
 corecmd_exec_bin(pacemaker_t)
 corecmd_exec_shell(pacemaker_t)
 
+domain_use_interactive_fds(pacemaker_t)
+domain_read_all_domains_state(pacemaker_t)
+
 dev_getattr_mtrr_dev(pacemaker_t)
 dev_read_rand(pacemaker_t)
 dev_read_urand(pacemaker_t)
 
-domain_read_all_domains_state(pacemaker_t)
-domain_use_interactive_fds(pacemaker_t)
-
 files_read_kernel_symbol_table(pacemaker_t)
 
 fs_getattr_all_fs(pacemaker_t)
@@ -75,9 +87,20 @@ auth_use_nsswitch(pacemaker_t)
 
 logging_send_syslog_msg(pacemaker_t)
 
-miscfiles_read_localization(pacemaker_t)
+sysnet_domtrans_ifconfig(pacemaker_t)
+
+tunable_policy(`pacemaker_use_execmem',`
+    allow pacemaker_t self:process { execmem };
+')
 
 optional_policy(`
 	corosync_read_log(pacemaker_t)
+	corosync_setattr_log(pacemaker_t)
 	corosync_stream_connect(pacemaker_t)
+	corosync_rw_tmpfs(pacemaker_t)
+')
+
+optional_policy(`
+	#executes heartbeat lib files
+	rgmanager_execute_lib(pacemaker_t)
 ')
Index: serefpolicy-contrib-20140730/pads.if
===================================================================
--- serefpolicy-contrib-20140730.orig/pads.if
+++ serefpolicy-contrib-20140730/pads.if
@@ -17,15 +17,19 @@
 ## </param>
 ## <rolecap/>
 #
-interface(`pads_admin', `
+interface(`pads_admin',`
 	gen_require(`
 		type pads_t, pads_config_t, pads_var_run_t;
 		type pads_initrc_exec_t;
 	')
 
-	allow $1 pads_t:process { ptrace signal_perms };
+	allow $1 pads_t:process signal_perms;
 	ps_process_pattern($1, pads_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 pads_t:process ptrace;
+	')
+
 	init_labeled_script_domtrans($1, pads_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 pads_initrc_exec_t system_r;
Index: serefpolicy-contrib-20140730/pads.te
===================================================================
--- serefpolicy-contrib-20140730.orig/pads.te
+++ serefpolicy-contrib-20140730/pads.te
@@ -25,8 +25,11 @@ files_pid_file(pads_var_run_t)
 #
 
 allow pads_t self:capability { dac_override net_raw };
+allow pads_t self:netlink_route_socket create_netlink_socket_perms;
 allow pads_t self:packet_socket create_socket_perms;
 allow pads_t self:socket create_socket_perms;
+allow pads_t self:udp_socket create_socket_perms;
+allow pads_t self:unix_dgram_socket create_socket_perms;
 
 allow pads_t pads_config_t:file manage_file_perms;
 files_etc_filetrans(pads_t, pads_config_t, file)
@@ -39,7 +42,6 @@ kernel_read_network_state(pads_t)
 
 corecmd_search_bin(pads_t)
 
-corenet_all_recvfrom_unlabeled(pads_t)
 corenet_all_recvfrom_netlabel(pads_t)
 corenet_tcp_sendrecv_generic_if(pads_t)
 corenet_tcp_sendrecv_generic_node(pads_t)
@@ -52,11 +54,8 @@ dev_read_rand(pads_t)
 dev_read_urand(pads_t)
 dev_read_sysfs(pads_t)
 
-files_read_etc_files(pads_t)
 files_search_spool(pads_t)
 
-miscfiles_read_localization(pads_t)
-
 logging_send_syslog_msg(pads_t)
 
 sysnet_dns_name_resolve(pads_t)
Index: serefpolicy-contrib-20140730/passenger.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/passenger.fc
+++ serefpolicy-contrib-20140730/passenger.fc
@@ -1,10 +1,12 @@
-/usr/.*/gems/.*/passenger-.*/ext/apache2/ApplicationPoolServerExecutable	--	gen_context(system_u:object_r:passenger_exec_t,s0)
-/usr/.*/gems/.*/passenger-.*/agents/PassengerWatchdog	--	gen_context(system_u:object_r:passenger_exec_t,s0)
-/usr/.*/gems/.*/passenger-.*/agents/PassengerLoggingAgent	--	gen_context(system_u:object_r:passenger_exec_t,s0)
-/usr/.*/gems/.*/passenger-.*/agents/apache2/PassengerHelperAgent	--	gen_context(system_u:object_r:passenger_exec_t,s0)
+/usr/share/gems/.*/Passenger.*	-- 	gen_context(system_u:object_r:passenger_exec_t,s0)
+/usr/share/gems/.*/ApplicationPoolServerExecutable	--  gen_context(system_u:object_r:passenger_exec_t,s0)
+/usr/lib/gems/.*/Passenger.*	-- 	gen_context(system_u:object_r:passenger_exec_t,s0)
+/usr/lib/gems/.*/ApplicationPoolServerExecutable  --  gen_context(system_u:object_r:passenger_exec_t,s0)	
 
-/var/lib/passenger(/.*)?	gen_context(system_u:object_r:passenger_var_lib_t,s0)
+/usr/share/.*/gems/.*/helper-scripts/prespawn	--	gen_context(system_u:object_r:passenger_exec_t,s0)
 
-/var/log/passenger.*	gen_context(system_u:object_r:passenger_log_t,s0)
+/var/lib/passenger(/.*)?		gen_context(system_u:object_r:passenger_var_lib_t,s0)
 
-/var/run/passenger(/.*)?	gen_context(system_u:object_r:passenger_var_run_t,s0)
+/var/log/passenger.*			gen_context(system_u:object_r:passenger_log_t,s0)
+
+/var/run/passenger(/.*)?		gen_context(system_u:object_r:passenger_var_run_t,s0)
Index: serefpolicy-contrib-20140730/passenger.if
===================================================================
--- serefpolicy-contrib-20140730.orig/passenger.if
+++ serefpolicy-contrib-20140730/passenger.if
@@ -15,17 +15,16 @@ interface(`passenger_domtrans',`
 		type passenger_t, passenger_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, passenger_exec_t, passenger_t)
 ')
 
 ######################################
 ## <summary>
-##	Execute passenger in the caller domain.
+##	Execute passenger in the current domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
 #
@@ -34,13 +33,30 @@ interface(`passenger_exec',`
 		type passenger_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, passenger_exec_t)
 ')
 
+#######################################
+## <summary>
+##  Getattr passenger log files
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`passenger_getattr_log_files',`
+    gen_require(`
+        type passenger_log_t;
+    ')
+
+    getattr_files_pattern($1, passenger_log_t, passenger_log_t)
+')
+
 ########################################
 ## <summary>
-##	Read passenger lib files.
+##	Read passenger lib files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -53,6 +69,112 @@ interface(`passenger_read_lib_files',`
 		type passenger_var_lib_t;
 	')
 
-	files_search_var_lib($1)
 	read_files_pattern($1, passenger_var_lib_t, passenger_var_lib_t)
+	read_lnk_files_pattern($1, passenger_var_lib_t, passenger_var_lib_t)
+	files_search_var_lib($1)
+')
+
+########################################
+## <summary>
+##	Manage passenger lib files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`passenger_manage_lib_files',`
+	gen_require(`
+		type passenger_var_lib_t;
+	')
+
+	manage_dirs_pattern($1, passenger_var_lib_t, passenger_var_lib_t)
+	manage_files_pattern($1, passenger_var_lib_t, passenger_var_lib_t)
+	manage_lnk_files_pattern($1, passenger_var_lib_t, passenger_var_lib_t)
+	files_search_var_lib($1)
+')
+
+#####################################
+## <summary>
+##  Manage passenger var_run content.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`passenger_manage_pid_content',`
+    gen_require(`
+        type passenger_var_run_t;
+    ')
+
+    files_search_pids($1)
+    manage_dirs_pattern($1, passenger_var_run_t, passenger_var_run_t)
+    manage_files_pattern($1, passenger_var_run_t, passenger_var_run_t)
+    manage_fifo_files_pattern($1, passenger_var_run_t, passenger_var_run_t)
+    manage_sock_files_pattern($1, passenger_var_run_t, passenger_var_run_t)
+')
+
+########################################
+## <summary>
+##	Connect to passenger unix stream socket.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`passenger_stream_connect',`
+	gen_require(`
+		type passenger_t;
+		type passenger_tmp_t;
+		type passenger_var_run_t;
+	')
+
+
+
+	stream_connect_pattern($1, passenger_var_run_t, passenger_var_run_t, passenger_t)
+	stream_connect_pattern($1, passenger_tmp_t, passenger_tmp_t, passenger_t)
 ')
+
+#######################################
+## <summary>
+##  Allow to manage passenger tmp files/dirs.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`passenger_manage_tmp_files',`
+    gen_require(`
+        type passenger_tmp_t;
+    ')
+
+    files_search_tmp($1)
+	manage_files_pattern($1, passenger_tmp_t, passenger_tmp_t)
+	manage_dirs_pattern($1, passenger_tmp_t, passenger_tmp_t)
+')
+
+########################################
+## <summary>
+##	Send kill signals to passenger.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`passenger_kill',`
+	gen_require(`
+		type passenger_t;
+	')
+
+	allow $1 passenger_t:process sigkill;
+')
+
Index: serefpolicy-contrib-20140730/passenger.te
===================================================================
--- serefpolicy-contrib-20140730.orig/passenger.te
+++ serefpolicy-contrib-20140730/passenger.te
@@ -1,4 +1,4 @@
-policy_module(passenger, 1.2.0)
+policy_module(passanger, 1.1.1)
 
 ########################################
 #
@@ -14,6 +14,9 @@ role system_r types passenger_t;
 type passenger_log_t;
 logging_log_file(passenger_log_t)
 
+type passenger_tmp_t;
+files_tmp_file(passenger_tmp_t)
+
 type passenger_var_lib_t;
 files_type(passenger_var_lib_t)
 
@@ -22,22 +25,24 @@ files_pid_file(passenger_var_run_t)
 
 ########################################
 #
-# Local policy
+# passanger local policy
 #
 
 allow passenger_t self:capability { chown dac_override fsetid fowner kill setuid setgid sys_nice sys_ptrace sys_resource };
-allow passenger_t self:process { setpgid setsched sigkill signal };
+allow passenger_t self:process { setpgid setsched sigkill signal signull };
 allow passenger_t self:fifo_file rw_fifo_file_perms;
-allow passenger_t self:unix_stream_socket { accept connectto listen };
+allow passenger_t self:tcp_socket listen;
+allow passenger_t self:unix_stream_socket { create_stream_socket_perms connectto };
+
+can_exec(passenger_t, passenger_exec_t)
 
 manage_dirs_pattern(passenger_t, passenger_log_t, passenger_log_t)
-append_files_pattern(passenger_t, passenger_log_t, passenger_log_t)
-create_files_pattern(passenger_t, passenger_log_t, passenger_log_t)
-setattr_files_pattern(passenger_t, passenger_log_t, passenger_log_t)
-logging_log_filetrans(passenger_t, passenger_log_t, file)
+manage_files_pattern(passenger_t, passenger_log_t, passenger_log_t)
+logging_log_filetrans(passenger_t, passenger_log_t, { dir file })
 
 manage_dirs_pattern(passenger_t, passenger_var_lib_t, passenger_var_lib_t)
 manage_files_pattern(passenger_t, passenger_var_lib_t, passenger_var_lib_t)
+files_search_var_lib(passenger_t)
 
 manage_dirs_pattern(passenger_t, passenger_var_run_t, passenger_var_run_t)
 manage_files_pattern(passenger_t, passenger_var_run_t, passenger_var_run_t)
@@ -45,7 +50,11 @@ manage_fifo_files_pattern(passenger_t, p
 manage_sock_files_pattern(passenger_t, passenger_var_run_t, passenger_var_run_t)
 files_pid_filetrans(passenger_t, passenger_var_run_t, { file dir sock_file })
 
-can_exec(passenger_t, passenger_exec_t)
+#needed by puppet
+manage_dirs_pattern(passenger_t, passenger_tmp_t, passenger_tmp_t)
+manage_files_pattern(passenger_t, passenger_tmp_t, passenger_tmp_t)
+manage_sock_files_pattern(passenger_t, passenger_tmp_t, passenger_tmp_t)
+files_tmp_filetrans(passenger_t, passenger_tmp_t, { file dir sock_file })
 
 kernel_read_system_state(passenger_t)
 kernel_read_kernel_sysctls(passenger_t)
@@ -53,13 +62,10 @@ kernel_read_network_state(passenger_t)
 kernel_read_net_sysctls(passenger_t)
 
 corenet_all_recvfrom_netlabel(passenger_t)
-corenet_all_recvfrom_unlabeled(passenger_t)
 corenet_tcp_sendrecv_generic_if(passenger_t)
 corenet_tcp_sendrecv_generic_node(passenger_t)
-
-corenet_sendrecv_http_client_packets(passenger_t)
 corenet_tcp_connect_http_port(passenger_t)
-corenet_tcp_sendrecv_http_port(passenger_t)
+corenet_tcp_connect_postgresql_port(passenger_t)
 
 corecmd_exec_bin(passenger_t)
 corecmd_exec_shell(passenger_t)
@@ -68,8 +74,6 @@ dev_read_urand(passenger_t)
 
 domain_read_all_domains_state(passenger_t)
 
-files_read_etc_files(passenger_t)
-
 auth_use_nsswitch(passenger_t)
 
 logging_send_syslog_msg(passenger_t)
@@ -94,14 +98,21 @@ optional_policy(`
 ')
 
 optional_policy(`
-	puppet_manage_lib_files(passenger_t)
+    mysql_stream_connect(passenger_t)
+    mysql_list_db(passenger_t)
+')
+
+optional_policy(`
+	puppet_domtrans_master(passenger_t)
+	puppet_manage_lib(passenger_t)
 	puppet_read_config(passenger_t)
-	puppet_append_log_files(passenger_t)
-	puppet_create_log_files(passenger_t)
-	puppet_read_log_files(passenger_t)
+	puppet_append_log(passenger_t)
+	puppet_create_log(passenger_t)
+	puppet_read_log(passenger_t)
+	puppet_search_pid(passenger_t)
 ')
 
 optional_policy(`
-	rpm_exec(passenger_t)
-	rpm_read_db(passenger_t)
+    rpm_exec(passenger_t)
+    rpm_read_db(passenger_t)
 ')
Index: serefpolicy-contrib-20140730/pcmcia.te
===================================================================
--- serefpolicy-contrib-20140730.orig/pcmcia.te
+++ serefpolicy-contrib-20140730/pcmcia.te
@@ -88,20 +88,17 @@ libs_exec_lib_files(cardmgr_t)
 
 logging_send_syslog_msg(cardmgr_t)
 
-miscfiles_read_localization(cardmgr_t)
-
 modutils_domtrans_insmod(cardmgr_t)
 
 sysnet_domtrans_ifconfig(cardmgr_t)
 sysnet_etc_filetrans_config(cardmgr_t)
 sysnet_manage_config(cardmgr_t)
 
-userdom_use_user_terminals(cardmgr_t)
+userdom_use_inherited_user_terminals(cardmgr_t)
 userdom_dontaudit_use_unpriv_user_fds(cardmgr_t)
 userdom_dontaudit_search_user_home_dirs(cardmgr_t)
 
 optional_policy(`
-	seutil_dontaudit_read_config(cardmgr_t)
 	seutil_sigchld_newrole(cardmgr_t)
 ')
 
Index: serefpolicy-contrib-20140730/pcp.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/pcp.fc
@@ -0,0 +1,28 @@
+/etc/rc\.d/init\.d/pmcd		--	gen_context(system_u:object_r:pcp_pmcd_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/pmlogger 	--      gen_context(system_u:object_r:pcp_pmlogger_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/pmproxy 	--	gen_context(system_u:object_r:pcp_pmproxy_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/pmwebd      --       gen_context(system_u:object_r:pcp_pmwebd_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/pmie      --       gen_context(system_u:object_r:pcp_pmie_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/pmmgr    --      gen_context(system_u:object_r:pcp_pmmgr_initrc_exec_t,s0)
+
+/usr/bin/pmie       --      gen_context(system_u:object_r:pcp_pmie_exec_t,s0)
+/usr/bin/pmcd	    --	    gen_context(system_u:object_r:pcp_pmcd_exec_t,s0)
+/usr/bin/pmlogger   --      gen_context(system_u:object_r:pcp_pmlogger_exec_t,s0)
+/usr/bin/pmproxy    --      gen_context(system_u:object_r:pcp_pmproxy_exec_t,s0)
+/usr/bin/pmwebd	    --	    gen_context(system_u:object_r:pcp_pmwebd_exec_t,s0)
+/usr/bin/pmmgr      --      gen_context(system_u:object_r:pcp_pmmgr_exec_t,s0)
+
+
+/usr/libexec/pcp/bin/pmcd	--	gen_context(system_u:object_r:pcp_pmcd_exec_t,s0)
+/usr/libexec/pcp/bin/pmlogger   --      gen_context(system_u:object_r:pcp_pmlogger_exec_t,s0)
+/usr/libexec/pcp/bin/pmproxy    --      gen_context(system_u:object_r:pcp_pmproxy_exec_t,s0)
+/usr/libexec/pcp/bin/pmwebd	--	gen_context(system_u:object_r:pcp_pmwebd_exec_t,s0)
+/usr/libexec/pcp/bin/pmie     --      gen_context(system_u:object_r:pcp_pmie_exec_t,s0)
+/usr/libexec/pcp/bin/pmmgr  --      gen_context(system_u:object_r:pcp_pmmgr_exec_t,s0)
+
+/var/lib/pcp(/.*)?		gen_context(system_u:object_r:pcp_var_lib_t,s0)
+
+/var/log/pcp(/.*)?		gen_context(system_u:object_r:pcp_log_t,s0)
+
+/var/run/pcp(/.*)?		gen_context(system_u:object_r:pcp_var_run_t,s0)
+/var/run/pmcd\.socket    --  gen_context(system_u:object_r:pcp_var_run_t,s0)
Index: serefpolicy-contrib-20140730/pcp.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/pcp.if
@@ -0,0 +1,139 @@
+## <summary>The  pcp  command summarizes the status of a Performance Co-Pilot (PCP) installation</summary>
+
+######################################
+## <summary>
+##  Creates types and rules for a basic
+##  pcp daemon domain.
+## </summary>
+## <param name="prefix">
+##  <summary>
+##  Prefix for the domain.
+##  </summary>
+## </param>
+#
+template(`pcp_domain_template',`
+    gen_require(`
+        attribute pcp_domain;
+    ')
+
+    type pcp_$1_t, pcp_domain;
+    type pcp_$1_exec_t;
+    init_daemon_domain(pcp_$1_t, pcp_$1_exec_t)
+
+    type pcp_$1_initrc_exec_t;
+    init_script_file(pcp_$1_initrc_exec_t)
+
+')
+
+######################################
+## <summary>
+##  Allow domain to read pcp lib files
+## </summary>
+## <param name="prefix">
+##  <summary>
+##  Prefix for the domain.
+##  </summary>
+## </param>
+#
+interface(`pcp_read_lib_files',`
+    gen_require(`
+        type pcp_var_lib_t;
+    ')
+    files_search_var_lib($1)
+    read_files_pattern($1,pcp_var_lib_t,pcp_var_lib_t)
+')
+
+########################################
+## <summary>
+##  All of the rules required to administrate
+##  an pcp environment
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+## <rolecap/>
+#
+interface(`pcp_admin',`
+    gen_require(`
+        type pcp_pmcd_t;
+        type pcp_pmlogger_t;
+        type pcp_pmproxy_t;
+        type pcp_pmwebd_t;
+        type pcp_pmie_t;
+        type pcp_pmmgr_t;
+        type pcp_var_run_t;
+    ')
+
+    allow $1 pcp_pmcd_t:process signal_perms;
+    ps_process_pattern($1, pcp_pmcd_t)
+
+    allow $1 pcp_pmlogger_t:process signal_perms;
+    ps_process_pattern($1, pcp_pmlogger_t)
+
+    allow $1 pcp_pmproxy_t:process signal_perms;
+    ps_process_pattern($1, pcp_pmproxy_t)
+
+    allow $1 pcp_pmwebd_t:process signal_perms;
+    ps_process_pattern($1, pcp_pmwebd_t)
+
+    allow $1 pcp_pmie_t:process signal_perms;
+    ps_process_pattern($1, pcp_pmie_t)
+
+    allow $1 pcp_pmmgr_t:process signal_perms;
+    ps_process_pattern($1, pcp_pmmgr_t)
+
+    tunable_policy(`deny_ptrace',`',`
+        allow $1 pcp_pmcd_t:process ptrace;
+        allow $1 pcp_pmlogger_t:process ptrace;
+        allow $1 pcp_pmproxy_t:process ptrace;
+        allow $1 pcp_pmwebd_t:process ptrace;
+        allow $1 pcp_pmie_t:process ptrace;
+        allow $1 pcp_pmmgr_t:process ptrace;
+    ')
+
+    files_search_pids($1)
+    admin_pattern($1, pcp_var_run_t)
+')
+
+########################################
+## <summary>
+##  Allow the specified domain to execute pcp_pmie
+##  in the caller domain.
+## </summary>
+## <param name="domain">
+## <summary>
+##  Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`pcp_pmie_exec',`
+    gen_require(`
+        type pcp_pmie_exec_t;
+    ')
+
+    corecmd_search_bin($1)
+    can_exec($1, pcp_pmie_exec_t)
+')
+
+########################################
+## <summary>
+##  Allow the specified domain to execute pcp_pmlogger
+##  in the caller domain.
+## </summary>
+## <param name="domain">
+## <summary>
+##  Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`pcp_pmlogger_exec',`
+    gen_require(`
+        type pcp_pmlogger_exec_t;
+    ')
+
+    corecmd_search_bin($1)
+    can_exec($1, pcp_pmlogger_exec_t)
+')
+
